﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace pr258_1
{
    // Обобщенный класс c одним параметром: 
    class Alpha<X> {
        // Поле обобщенного типа: 
        public X code;
        // Конструктор: 
        public Alpha(X a) { 
            code = a;
        }
        // Метод:
        public void show() {
            Console.WriteLine("Поле типа {0}: {1}", typeof(X).Name, code);
        }
    }

    // Обобщенный класс с двумя параметрами: 
    class Bravo<X, Y> {
        // Поля обобщенного типа: 
        public X first; 
        public Y second;
        // Конструктор: 
        public Bravo(X a, Y b) { 
            first = a; 
            second = b;
        }
        // Метод:
        public void show(){
            Console.WriteLine("Первое поле типа {0}: {1}", typeof(X).Name, first); 
            Console.WriteLine("Второе поле типа {0}: {1}", typeof(Y).Name, second);
        }
    }

    // Главный класс: 
    class Program
    {
        static void Main()
        {
            // Создание объектов обобщенного класса:
            Alpha<int> A = new Alpha<int>(123);
            Alpha<string> B = new Alpha<string>("object B");
            Alpha<char> C = new Alpha<char>('C');
            // Вызов методов из объектов обобщенного класса:
            A.show();
            B.show();
            C.show();
            Console.WriteLine();
            // Создание объектов обобщенного класса:
            Bravo<int, char> objA = new Bravo<int, char>(123, 'A');
            Bravo<string, bool> objB = new Bravo<string, bool>("objB", true); 
            Bravo<char, char> objC = new Bravo<char, char>('B', 'C');
            // Вызов методов из объектов обобщенного класса:
            objA.show();
            objB.show();
            objC.show();
            // Задержка:
            Console.ReadLine();
        }
    }
}
